!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
!~~~~~                 condizioni ai bordi aperti                        ~~~~~! 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
      SUBROUTINE BCOND(IDX) 
!-----------------------------------------------------------------------------! 
      INCLUDE 'comblk98_lamp.fi'    
!-----------------------------------------------------------------------------! 
 
!###### calcolo forzanti periodiche per Flather Condition a EAST #####! 
 
!---------- UAe climatologica
!      tempo=(iINT-1)*DTE*iSPLIT+DTE*iEXT 
!      do j=1,JM 
!       UAe(j)=-0.278+0.132*sin(2*pi/(17*86400)*tempo)
!       UAe(j)=-0.061+0.053*sin(2*pi/(17*86400)*tempo)
!       UAe(j)=-0.095+0.124*sin(2*pi/(17*86400)*tempo)
!       UAe(j)=-0.157+0.153*sin(2*pi/(17*86400)*tempo)
!      enddo 
!-----forzante realistica da dati 1978-79 a Sestri
      if(mod(IINT,IORA).eq.0)then
       iserie=IINT/IORA
       do j=1,JM
        UAe(j)=serieUAe(iserie)
       enddo
      endif

!---------- ELe 
      ELe(1)=0. 
       do j=2,JM 
        ELe(j)=ELe(j-1)-COR(1,j)*UAe(j)/GRAV*DY(1,j-1) 
       enddo 
      ELeJmid=ELe(JMM1/2) 
      do j=2,JMM1 
       ELe(j)=(ELe(j)-ELeJmid)*FSM(IM,j) 
      enddo 
      ELe(1)=ELe(2) 
      ELe(JM)=ELe(JMM1) 
 
!################################## 
 
      GO TO (10,20,30,40,50,60,70), IDX 
 
!################################ ELEVATION ################################### 
10    CONTINUE 
      do j=1,JM 
!-----------------------------   EAST   ---------------------------------------
      i=IM 
 
!>>>>>Clamped 
!      ELF(IM,j)=0. 
 
!>>>>>Zero Gradient 
       ELF(IM,j)=ELF(IMM1,j) 
 
!>>>>>Radiazione Marcello mBCcv901.f 
!	  GAE=DTE*sqrt(GRAV*H(IMM1,j))/DX(IMM1,j) 
!	  ELF(IMM1,j)=GAE*EL(IMM2,j)+(1.-GAE)*EL(IMM1,j) 
!	  ELF(IM,j)=ELF(IMM1,j)  !cm cosmetica 
 
!>>>>>Orlanski 
!      CPHDTX=SQRT(GRAV*H(IM,j))*DTE/DX(IM,j) 
!      veldtds=UA(IMM1,j)*DTE/DX(IMM1,j) 
!      CPHDTX=olansk(veldtds,ELB(IMM1,j),EL(IMM2,j),ELF(IMM1,j)) 
!      ELF(IM,j)=(ELB(IM,j)-CPHDTX*(ELB(IM,j)-2.0*EL(IMM1,j))) 
!     &        /(1.0+CPHDTX) 
 
!=====SOFT START 
!	ELF(IM,j)=ELF(IM,j)*RAMP 
!-----------------------------   WEST   --------------------------------------- 
      i=1 
 
!>>>>>Clamped 
!      ELF(1,j)=0. 
 
!>>>>>Zero Gradient 
       ELF(1,j)=ELF(2,j) 
 
!>>>>>Radiazione Marcello mBCcv901.f 
!	  GAE=DTE*sqrt(GRAV*H(2,j))/DX(1,j) 
!	  ELF(2,j)=GAE*EL(3,j)+(1.-GAE)*EL(2,j) 
!	  ELF(1,j)=ELF(2,j) !cm cosmetica 
 
!>>>>>Orlanski 
!      CPHDTX=SQRT(GRAV*H(1,j))*DTE/DX(1,j) 
!      veldtds=-UA(3,j)*DTE/DX(3,j) 
!      CPHDTX=olansk(veldtds,ELB(2,j),EL(3,j),ELF(2,j)) 
!      ELF(1,j)=(ELB(1,j)+CPHDTX*(2.0*EL(2,j)-ELB(1,j))) 
!     &         /(1.0+CPHDTX) 
	 
!=====SOFT START 
!      ELF(1,j)=ELF(1,j)*RAMP 
 
      enddo 
 
      do i=1,IM 
!-----------------------------   NORTH   -------------------------------------- 
      j=JM 
 
!>>>>>Clamped 
!      ELF(i,JM)=0. 
 
!>>>>>Zero Gradient 
!      ELF(i,JM)=ELF(i,JMM1) 
 
!>>>>>Orlanski 
!      CPHDTY=SQRT(GRAV*H(i,JM))*DTE/DY(i,JM) 
!      veldtds=VA(i,JMM1)*DTE/DY(i,JMM1) 
!      CPHDTY=olansk(veldtds,ELB(i,JMM1),EL(i,JMM2),ELF(i,JMM1)) 
!      ELF(i,j)=(ELB(i,j)-CPHDTY*(ELB(i,j)-2.0*EL(i,JMM1))) 
!     &        /(1.0+CPHDTY) 
 
!=====SOFT START 
!      ELF(i,JM)=ELF(i,JM)*RAMP 
!-----------------------------   SOUTH   -------------------------------------- 
      j=1 
 
!>>>>>Clamped 
!      ELF(i,2)=0. 
 
!>>>>>Zero Gradient 
       ELF(i,1)=ELF(i,2) 
 
!>>>>>Orlanski 
!      CPHDTY=SQRT(GRAV*H(i,1))*DTE/DY(i,1) 
!      veldtds=-VA(i,3)*DTE/DY(i,3) 
!      CPHDTY=olansk(veldtds,ELB(i,2),EL(i,3),ELF(i,2)) 
!      ELF(i,1)=(ELB(i,1)+CPHDTY*(2.0*EL(i,2)-ELB(i,1))) 
!     &          /(1.E0+CPHDTY) 
 
!=====SOFT START 
!      ELF(i,1)=ELF(i,1)*RAMP 
 
      enddo 
 
!!!!!!MASCHERA 
 
      DO j=1,JM 
       DO i=1,IM 
        ELF(i,j)=ELF(i,j)*FSM(i,j) 
       ENDDO 
      ENDDO 
 
      RETURN 
 
!############################ MEAN VELOCITY ################################### 
20    CONTINUE 
	 
      do j=1,JM 
!-----------------------------   EAST   --------------------------------------- 
 
      i=IM 
 
!#### NORMAL COMPONENT 
!>>>>>Clamped 
!      UAF(IM,j)=0. 
 
!>>>>>Zero Gradient 
!      UAF(IM,j)=UAF(IMM1,j) 
 
!>>>>>Flather 
       UAF(IM,j)=UAe(j)+sqrt(GRAV/H(IMM1,j))*(EL(IMM1,j)-ELe(j)) 
 
!>>>>>Orlanski 
!      CPHDTX2=SQRT(GRAV*H(IM,J))*DTE/DX(IM,J) 
!      veldtds=UA(IMM1,j)*DTE/DX(IMM1,j) 
!      CPHDTX2=olansk(veldtds,uab(IMM1,j),ua(IMM2,j),uaf(IMM1,j)) 
!      UAF(IM,j)=(UAB(IM,j)-CPHDTX2*(UAB(IM,j)-2.0*UA(IMM1,j))) 
!     &         /(1.0+CPHDTX2) 
 
!#### TANGENTIAL COMPONENT 
!>>>>>Clamped 
       VAF(IM,j)=0. 
 
!>>>>>Zero Gradient 
!      VAF(IM,j)=VAF(IMM1,j) 
 
!>>>>>Orlanski 
!      CPHDTX2=SQRT(GRAV*H(IM,j))*DTE/DX(IM,j) 
!      veldtds=ua(IMM1,j)*dte/dx(IMM1,j) 
!      CPHDTX2=olansk(veldtds,vab(IMM1,j),va(IMM2,j),vaf(IMM1,j)) 
!      VAF(IM,j)=(VAB(IM,j)-CPHDTX2*(VAB(IM,j)-2.0*VA(IMM1,j))) 
!     &         /(1.0+CPHDTX2) 
 
!=====SOFT START 
!      UAF(IM,j)=UAF(IM,j)*RAMP 
!      VAF(IM,j)=VAF(IM,j)*RAMP 
 
!-----------------------------   WEST   --------------------------------------- 
 
      i=1 
 
!#####NORMAL COMPONENT 
!>>>>>Clamped 
!      UAF(2,j)=0. 
 
!>>>>>Zero Gradient 
!      UAF(2,j)=UAF(3,j) 
 
!>>>>>Flather 
!      UAF(2,j)=UAw(j)-sqrt(GRAV/H(2,j))*(EL(2,j)-ELw(j)) 
 
!>>>>>Orlanski 
       CPHDTX1=SQRT(GRAV*H(2,J))*DTE/DX(2,J) 
!      veldtds=-UA(3,j)*DTE/DX(3,j) 
!      CPHDTX1=olansk(veldtds,UAB(3,j),UA(4,j),UAF(3,j)) 
       UAF(2,J)=(UAB(2,J)+CPHDTX1*(2.0*UA(3,J)-UAB(2,J))) 
     &         /(1.0+CPHDTX1) 
 
 
!#####TANGENTIAL COMPONENT 
!>>>>>Clamped 
!      VAF(i,j)=0. 
 
!>>>>>Zero Gradient 
!      VAF(1,j)=VAF(2,j) 
 
!>>>>>Orlanski 
       CPHDTX1=SQRT(GRAV*H(1,j))*DTE/DX(1,j) 
!      veldtds=-VA(3,j)*DTE/DX(3,j) 
!      CPHDTX1=olansk(veldtds,VAB(2,j),VA(3,j),VAF(2,j)) 
       VAF(1,j)=(VAB(1,j)+CPHDTX1*(2.0*VA(2,j)-VAB(1,j))) 
     &        /(1.0+CPHDTX1) 
 
!=====SOFT START 
!      UAF(1,j)=UAF(1,j)*RAMP 
!      VAF(1,j)=VAF(1,j)*RAMP 
      enddo 
 
      do i=1,IM 
!-----------------------------   NORTH   -------------------------------------- 
 
      j=JM 
 
!#####NORMAL COMPONENT 
!>>>>>Clamped 
!      VAF(i,JM)=0. 
 
!>>>>>Zero gradient 
!      VAF(i,JM)=VAF(i,JMM1) 
 
!>>>>>Flather 
!      VAF(i,JM)=VAn(i)+sqrt(GRAV/H(i,JMM1))*(EL(i,JMM1)-ELn(i)) 
 
!>>>>>Orlanski 
!      CPHDTY2=SQRT(GRAV*H(i,JM))*DTE/DY(i,JM) 
!      veldtds=VA(i,JMM1)*DTE/DY(i,JMM1) 
!      CPHDTY2=olansk(veldtds,VAB(i,JMM1),VA(i,JMM2),VAF(i,JMM1)) 
!      VAF(i,JM)=(VAB(i,JM)-CPHDTY2*(VAB(i,JM)-2.0*VA(i,JMM1))) 
!     &         /(1.0+CPHDTY2) 
 
!#####TANGENTIAL COMPONENT 
!>>>>>Clamped 
!      UAF(i,JM)=0. 
 
!>>>>>Zero gradient 
!      UAF(i,JM)=UAF(i,JMM1) 
 
!>>>>>Orlanski 
!      CPHDTY2=SQRT(GRAV*H(i,JM))*DTE/DY(i,JM) 
!      veldtds=VA(i,JMM1)*dte/dy(i,JMM1) 
!      CPHDTY2=olansk(veldtds,UAB(i,JMM1),UA(i,JMM2),UAF(i,JMM1)) 
!      UAF(i,JM)=(UAB(i,JM)-CPHDTY2*(UAB(i,JM)-2.0*UA(i,JMM1))) 
!     &         /(1.0+CPHDTY2) 
 
!=====SOFT START 
!      UAF(i,JM)=UAF(i,JM)*RAMP 
!      VAF(i,JM)=VAF(i,JM)*RAMP 
 
!-----------------------------   SOUTH   -------------------------------------- 
 
      j=1 
 
!#####NORMAL COMPONENT 
!>>>>>Clamped 
      VAF(i,2)=0. 
 
!>>>>>Zero gradient 
!      VAF(i,2)=VAF(i,3) 
 
!>>>>>Flather 
!      VAF(i,2)=VAs(i)-sqrt(GRAV/H(i,2))*(EL(i,2)-ELs(i)) 
 
!>>>>>Orlanski 
!      CPHDTY1=SQRT(GRAV*H(i,2))*DTE/DY(i,2) 
!      veldtds=-VA(i,3)*DTE/DY(i,3) 
!      CPHDTY1=olansk(veldtds,VAB(i,3),VA(i,4),VAF(i,3)) 
!      VAF(i,2)=(VAB(i,2)+CPHDTY1*(2.0*VA(i,3)-VAB(i,2))) 
!     &        /(1.E0+CPHDTY1) 
 
!#####TANGENTIAL COMPONENT 
!>>>>>Clamped 
!      UAF(i,1)=0. 
 
!>>>>>Zero gradient 
      UAF(i,1)=UAF(i,2) 
 
!>>>>>Orlanski 
!      CPHDTY1=SQRT(GRAV*H(i,1))*DTE/DY(I,1) 
!      veldtds=-VA(i,3)*DTE/DY(i,3) 
!      CPHDTY1=olansk(veldtds,UAB(i,2),UA(i,3),UAF(i,2)) 
!      UAF(i,1)=(UAB(i,1)+CPHDTY1*(2.0*UA(i,3)-UAB(i,1))) 
!     &        /(1.E0+CPHDTY1) 
 
!=====SOFT START 
!      UAF(i,1)=UAF(i,1)*RAMP 
!      VAF(i,1)=VAF(i,1)*RAMP 
      enddo 
 
!!!!!!MASCHERA 
      DO j=1,JM 
       DO i=1,IM 
        UAF(i,j)=UAF(i,j)*DUM(i,j) 
        VAF(i,j)=VAF(i,j)*DVM(i,j) 
!cosmetic 
        VAF(i,1)=VAF(i,2) 
       ENDDO 
!cosmetic 
       UAF(1,j)=UAF(2,j) 
      ENDDO 
 
      RETURN 
 
!######################## INTERNAL VELOCITY ################################### 
30    CONTINUE 

 
      RETURN 
!####################### TEMP(UF) & SAL(VF) B.C.'S ############################ 
40    CONTINUE 
 
      RETURN 
!######################## VERTICAL VEL. B.C.'S ################################ 
50    CONTINUE 
     
      RETURN 
!######################## Q2(UF) & Q2L(VF) B.C.'S ############################# 
60    CONTINUE 
 
      RETURN 
 
!######################## WUSURF & WVSURF B.C.'S ############################## 
70    CONTINUE 
!      iread=3600/DTI !0.041666667*24*3600/DTI !OGNI ORA nb:0.041666=1/24
!      iread=6*iread
!      if(mod(IINT,iread).eq.0)then
!       i6ore=IINT/iread
!        do j=40,JM 
!         do i=45,100 !vento solo sul golfo tigullio 
!          WUSURF(i,j)=Wu(i6ore) 
!          WVSURF(i,j)=Wv(i6ore)
!         enddo
!       enddo
!      endif      
 
      RETURN 
!------------------------------------------------------------------------------ 
 
      END 
 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
 
!*DECK MOLANSK 
!     Modified Orlanski 
!     from /ost/lyo/gom/nl/nl41k.f    ... l.oey  [11/24/95] 
 
      function molansk(veldtds,elb,el,elf) 
      CO=(ELB-ELF)/(ELF+ELB-2.*EL+1.E-18) + VELDTDS 
      if(CO.gt.0.0)then 
      molansk=1.0 
      else 
      molansk=0.0 
      endif 
      return 
      end 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
 
!*DECK OLANSK 
!     Original Orlanski 
!     from nl41l.f    ... l.oey  [11/12/95] 
 
      function olansk(veldtds,elb,el,elf) 
      CO=(ELB-ELF)/(ELF+ELB-2.*EL+1.E-18) + VELDTDS 
      if(CO.ge.1.0)then 
      olansk=1.0 
      else 
      if(CO.gt.0.0)then 
      olansk=CO 
      else 
      olansk=0.0 
      endif 
      endif 
      return 
      end 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
 
 
 
 









