!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
!~~~~~        specifiche simulazione e condizioni iniziali               ~~~~~! 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
!31/01/2006=>AD: new sr for random numbers by Alain NOULLEZ
!16/05/2002=>AD: modificato assegnazione maschere
!   2001   =>AD&MM first changes on the basis of bcond by pom98
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                          SOFTWARE LICENSING                  
!    This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License (GPL) as published 
! by the Free Software Foundation, either Version 2 of the license, or 
! (at your option) any later version.
!   This program is distributed  in the hope that  it  will be useful, but 
! without any warranty; without even the implied warranty of merchantabil-
! ity or fitness for a particular purpose. See  the GPL  for more details. 
!   A copy of the GNU General Public License is available at 
!                   http://www.gnu.org/copyleft/gpl.html   
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
      SUBROUTINE ICOND(datadir,recNUMsim,NREAD,TSURF,SSURF,TCLIM,SCLIM)      
 
!-----------------------------------------------------------------------------! 
      INCLUDE 'comblk98_lamp.fi' 
      CHARACTER*3  recNREADsim 
 
      DIMENSION TSURF(IM,JM),SSURF(IM,JM), 
     &         TCLIM(IM,JM,KB),SCLIM(IM,JM,KB), 
     &         DRHOX(IM,JM,KB),DRHOY(IM,JM,KB),DRX2D(IM,JM),DRY2D(IM,JM) 
 
!-----------------------------------------------------------------------------! 
 
      INCLUDE 'params98_lamp.fi' 

	write(*,*) 'Start sr ICOND' 
!====================== preparazione griglia =================================! 
!->   griglia verticale 
      CALL DEPTH(datadir,recNUMsim,6,Z,ZZ,DZ,DZZ,KB) !KL1=2 =>griglia regolare 
 
!->   griglia orizzontale 
      do j=1,JM 
       do i=1,IM 
        DX(i,j)=400. 
        DY(i,j)=200. 
       enddo 
      enddo  

!     preparazione griglie 
      open(18,file=datadir//'i_ics'//recNUMsim//'.txt') 
      i=1 
      X(i)=0. 
      write(18,'(I5,F12.5)') i,X(i)/1000. 
 
      open(19,file=datadir//'j_ipsilon'//recNUMsim//'.txt') 
      j=1 
      Y(j)=0. 
      write(19,'(I5,F12.5)') j, Y(j)/1000. 
 
      X(1)=0. 
      DO I=2,IM 
       X(I)=X(I-1)+DX(I-1,1) 
       write(18,'(I5,F12.5)') i,X(i)/1000. 
      ENDDO 
      Y(1)=0. 
      DO J=2,JM 
       Y(J)=Y(J-1)+DY(1,J-1) 
       write(19,'(I5,F12.5)') j, Y(j)/1000. 
      ENDDO 
      DO J=1,JM 
       DO I=1,IM 
        ART(I,J)=DX(I,J)*DY(I,J) 
       ENDDO 
      ENDDO 
      DO J=2,JM 
       DO I=2,IM 
        ARU(I,J)=.25*(DX(I,J)+DX(I-1,J))*(DY(I,J)+DY(I-1,J)) 
        ARV(I,J)=.25*(DX(I,J)+DX(I,J-1))*(DY(I,J)+DY(I,J-1)) 
       ENDDO 
      ENDDO 
      DO J=1,JM 
       ARU(1,J)=ARU(2,J) 
       ARV(1,J)=ARV(2,J) 
      ENDDO 
      DO I=1,IM 
       ARU(I,1)=ARU(I,2) 
       ARV(I,1)=ARV(I,2) 
      ENDDO 
 
      close(18) 
      close(19) 
 
!============ batimetria, maschere, param. Coriolis e rugosita' fondo =========!  
!->   valore terraferma 
      terra=1. 
!->   batimetria 
! 
      !=== LETTURA BATIMETRIA VERA 
!      open(21,file='../POM_DATA/INPUT/batimetria_marcello.dat', 
      open(21,file='../POM_DATA/INPUT/batimetria_corretta.dat', 
     &        status='old') 
 
      do ir=1,7 
        read(21,*) 
      enddo 
      do j=JM,1,-1 
        read(21,'(115(f10.4,10x))') (H(i,j), i=1,IM) 
      enddo 
      close(21) 
 
!      do i=1,IM 
!       do j=1,10 
!        H(i,j)=H(i,11)  !bordo SUD spianato 
!       enddo 
!       H(i,1)=1.        !e chiuso 
!      enddo 
 
!FA&PO-CONTROLLO Profondita` livelli Zlamp maggiori della batimetria 
      do j=0,JMLAMP 
         do i=0,IMLAMP 
            if((-deltaZ*O).le.H(i+IOLAMP,j+JOLAMP))then 
               write(*,*)'' 
               write(*,*)'Controllo profondita` LAMP non rispettato' 
               write(*,*)' => STOP' 
               stop 
            endif 
         enddo 
       enddo 
       write(*,*)'' 
       write(*,*)'Controllo profondita` rispettato ' 
       write(*,*)' => OK' 
 
!     preparazione maschere 
      DO J=1,JM 
       DO I=1,IM 
        FSM(I,J)=1. 
        DUM(I,J)=1. 
        DVM(I,J)=1. 
        IF(H(I,J).eq.terra) FSM(I,J)=0. 
       ENDDO 
      ENDDO 
      DO J=2,JM 
       DO I=2,IM 
        DUM(I,J)=FSM(I,J)*FSM(I-1,J)                                 
        DVM(I,J)=FSM(I,J)*FSM(I,J-1)                                      
       ENDDO 
      ENDDO 
 
!->   Coriolis 
      do i=1,IM 
       do j=1,JM 
        COR(I,J)=1.03E-04 
       enddo 
      enddo 
 
!->   rugosita'(CBC serve per il calcolo di WUBOT e WVBOT) 
      do i=1,IM 
       do j=1,JM 
        CBC(i,j)=0.0025 
!         Z0B=.01 
!         CBCMIN=.0025E0                        
!  45     CBC(I,J)=MAX(CBCMIN,.16E0/LOG((ZZ(KBM1)-Z(KB))*H(I,J)/Z0B)**2) 
!     1            *FSM(I,J) 
       enddo 
      enddo 
!====================== condizioni iniziali ==================================! 
!HOT START
!->   Lettura dati per Hot Start
!      febbraio 
      call READxy('ELB__219',ELB,IM,JM,10)
      call READxy('UAB__219',UAB,IM,JM,10)
      call READxy('VAB__219',VAB,IM,JM,10)
!     novembre 
!      call READxy('ELB__221',ELB,IM,JM,10)
!      call READxy('UAB__221',UAB,IM,JM,10)
!      call READxy('VAB__221',VAB,IM,JM,10)

!     riassegnazioni 
!->   velocita' 
!      tempo=0. 
!      do j=1,JM 
!       UAe(j)=-0.278+0.132*sin(2*pi/(17*86400)*tempo)
!       UAe(j)=-0.061+0.053*sin(2*pi/(17*86400)*tempo)
!       UAe(j)=-0.095+0.124*sin(2*pi/(17*86400)*tempo)
!       UAe(j)=-0.157+0.153*sin(2*pi/(17*86400)*tempo)
!      enddo 
      !---LETTURA DATI
      open(21,file='../POM_DATA/INPUT/meaninflow_n3408_08Feb79_30Jun79.
!      open(21,file='../POM_DATA/INPUT/meaninflow_n0974_23Sep78_02Nov78.
!      open(21,file='../POM_DATA/INPUT/meaninflow_n1313_14Nov78_08Jan79.
!      open(21,file='../POM_DATA/INPUT/meaninflow_n1458_08Feb79_10Apr79.
!      open(21,file='../POM_DATA/INPUT/meaninflow_n1219_10Apr79_31May79.
!      open(21,file='../POM_DATA/INPUT/meaninflow_n0721_31May79_30Jun79.
     &txt',status='old')
      do iserie=1,Nore 
       read(21,'(F12.5)') serieUAe(iserie)
       write(*,*)'serieUAe=',serieUAe(iserie)
      enddo
      do j=1,JM
         UAe(j)=serieUAe(1)
      enddo
!->   elevazione
      ELe(1)=0.
      do j=2,JM
       ELe(j)=ELe(j-1)-COR(1,j)*UAe(j)/GRAV*DY(1,j-1)
      enddo
      ELeJmid=ELe(JMM1/2)
      do j=2,JMM1
       ELe(j)=(ELe(j)-ELeJmid)*FSM(IM,j)
      enddo
      ELe(1)=ELe(2)
      ELe(JM)=ELe(JMM1)
      do j=1,JM 
       do i=1,IM 
        EL(i,j)=ELB(i,j) 
        ETB(i,j)=ELB(i,j) 
        ET(i,j)=ELB(i,j) 
        D(I,J)=H(I,J)+EL(I,J) 
        DT(I,J)=H(I,J)+ET(I,J) 
       enddo 
      enddo 

!COLD START
!->   velocita' 
!      tempo=0. 
!      do j=1,JM 
!       UAe(j)=-0.278+0.132*sin(2*pi/(17*86400)*tempo)
!       UAe(j)=-0.061+0.053*sin(2*pi/(17*86400)*tempo)
!       UAe(j)=-0.095+0.124*sin(2*pi/(17*86400)*tempo)
!       UAe(j)=-0.157+0.153*sin(2*pi/(17*86400)*tempo)
!      enddo 

!      do j=1,JM 
!       do i=1,IM 
!        UAB(i,j)=UAe(j)
!        VAB(i,j)=0. 
!        UA(i,j)=UAe(j)
!        VA(i,j)=0. 
!       enddo 
!      enddo 
 
!->    elevazione 
       !=== CALCOLATO TUTTO IL CAMPO INIZIALE CON FORMULA GEOSTROFICA 
!       do i=1,IM 
!       ELB(i,1)=0. 
!        do j=2,JM 
!         ELB(i,j)=ELB(i,j-1)+COR(i,j)/GRAV* 
!     &        (VAB(i,j)*DX(i,j-1)-UAB(i,j)*DY(i,j-1)) 
!        enddo 
!       enddo 
!       do i=1,IM 
!        ELBJmid=ELB(i,10) 
!        do j=1,JM 
!         ELB(i,j)=(ELB(i,j)-ELBJmid)*FSM(i,j) 
!        enddo 
!       enddo 
! 
!       do j=1,JM 
!        do i=1,IM 
!         EL(i,j)=ELB(i,j) 
!         ETB(i,j)=ELB(i,j) 
!         ET(i,j)=ELB(i,j) 
!         D(I,J)=H(I,J)+EL(I,J) 
!         DT(I,J)=H(I,J)+ET(I,J) 
!        enddo 
!       enddo 
 
!->    viscosita' e diffusivita' orizzontale 
       do j=1,JM 
        do i=1,IM 
           AAM2D(I,J)=1. 
        enddo 
       enddo 


!=============================================================================! 
!     gradiente di pressione baroclino 
      CALL BAROPG(DRHOX,DRHOY) 
      DO K=1,KBM1 
       DO J=1,JM 
        DO I=1,IM  
         DRX2D(I,J)=DRX2D(I,J)+DRHOX(I,J,K)*DZ(K) 
         DRY2D(I,J)=DRY2D(I,J)+DRHOY(I,J,K)*DZ(K) 
        ENDDO 
       ENDDO 
      ENDDO 
 
!->   vento 
!      open(33,file='../POM_DATA/INPUT/surf0693.txt',status='old')
!555    format(E13.5,1X,E13.5)
!       do it=1,N6ore
!        read(33,555) Wu(it),Wv(it)
!       enddo
!      close(33)
      do j=1,JM 
       do i=1,IM
        WUSURF(i,j)=0.
        WVSURF(i,j)=0.
       enddo 
      enddo
!      do j=40,JM 
!       do i=45,100 !vento solo sul golfo tigullio 
!        WUSURF(i,j)=Wu(1)
!        WVSURF(i,j)=Wv(1)
!       enddo 
!      enddo
 
************************************************************************ 
*                   CONDIZIONI INIZIALI PER LAMP3D                     * 
************************************************************************ 
 
       deltaX=DX(IOLAMP,JOLAMP) 
       deltaY=DY(IOLAMP,JOLAMP) 

! inizializzazione estrazione numeri pseudorandom 
      trash=ranx(seme)
*     sigma 
       do j=1,JMLAMP 
        do i=1,IMLAMP 
         SIGMA(i,j)=3.46 
        enddo 
       enddo 
 
*     concentrazione iniziale in particelle 
	do k=O,0 
	 do j=1,JMLAMP 
	  do i=1,IMLAMP 
             CONC(i,j,k)=0. 
	  enddo 
	 enddo 
	enddo 
 
 
        ISORGENTE=(IMLAMP/2) 
        JSORGENTE=(JMLAMP/2) 
        KSORGENTE=(-2) 
 
        intCONCZERO=0 
 
	CONC(ISORGENTE,JSORGENTE,KSORGENTE)=intCONCZERO 
 
!FA&PO-CONTROLLO SUL NUMERO DI PARTICELLE 
        Npartnecessarie=(DAYS*24*3600/DTI+2)*iFLUXSORGENTE+intCONCZERO 
        if(Npartnecessarie.gt.Nparticelle) then 
           write(*,*)'' 
           write(*,*)'memoria allocata per le particelle insufficiente' 
           write(*,*)'Npartnecessarie=',Npartnecessarie 
           write(*,*)'Nparticelle    =',Nparticelle 
           stop 
        endif 

*-------------------------------------------------------------------- 
*     contatori delle particelle eliminate 
      Icmorte=0          
      Icfuori=0 
 
 
*---- assegnazione posizione iniziale simbolica per tutte le particelle 
      do Ip=1,Nparticelle 
        Xpart(Ip)=-999 
        Ypart(Ip)=-999 
        Zpart(Ip)=999 
      enddo 
*---- assegnazione vettore SURVPROB (possibilita` di sopravvivenza) 
      do Ip=1,Nparticelle            
        SURVPROB(Ip)=-9              
      enddo                          
*---- assegnazione posizioni iniziali da conc. iniziale 
 
      Icnate=0 
 
        do J=JMLAMP-1,1,-1 
        do I=1,IMLAMP-1 
        do K=0,O,-1 
            newNp=NINT(CONC(i,j,k))+Icnate 
            do Ip=Icnate+1,newNp 
              SURVPROB(Ip)=1 
              Icnate=Icnate+1 
              Xpart(Ip)=i*deltaX      
              Ypart(Ip)=j*deltaY 
              Zpart(Ip)=k*deltaZ 
!             write(*,*)Xpart(Ip),Ypart(Ip),Zpart(Ip)  
            enddo 
            Icnate=newNp 
        enddo 
        enddo 
        enddo 
 
      write(*,*)'Icnate=',Icnate 
*---- assegnazione del seme per i numeri pseudorandom fuori dal ciclo temporale 
!       call seed(seme) 
        
!-------------------------------------------------------- 

      write(*,*) 'Finish sr ICOND' 

      RETURN 
      END 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
