!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!      LAMP3D      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!      Lagrangian Assessment for Marine Pollution 3-Dimensional model      ! 
!                                                                          !
!--------------------------------------------------------------------------! 
!22/02/2000=>Vs 1.9, lavoro tesi di Andrea Doglioli, modello off-line
!	     con mike21
!13/02/2002=>Vs 2.9, lavoro tesi di Marcello Magaldi, modello in-line
!            con pom98
!11/06/2004=>Vs 3.0, implementazione biodegradazione Findlay-Watling model 
!            A.Doglioli e P.Vassallo
!25/06/2004=>AD: new bcond for Wekman based on messo zero-gradient
!15/12/2004=>AD: sintetic currentmeters in tig2 position
!15/12/2005=>AD: estethic restyling
!31/01/2006=>AD: new sr for random numbers by Alain NOULLEZ
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                          SOFTWARE LICENSING                  
!    This program is free software; you can redistribute it and/or modify
! it under the terms of the GNU General Public License (GPL) as published 
! by the Free Software Foundation, either Version 2 of the license, or 
! (at your option) any later version.
!   This program is distributed  in the hope that  it  will be useful, but 
! without any warranty; without even the implied warranty of merchantabil-
! ity or fitness for a particular purpose. See  the GPL  for more details. 
!   A copy of the GNU General Public License is available at 
!                   http://www.gnu.org/copyleft/gpl.html   
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	subroutine LAMP3D(datadir,recNUMsim)
!--------------------------------------------------------------------------!
!WINDOWS 
!	use DFLIB 
!	use DFWIN 
! 
!	type (windowconfig) wc15 
!	type (qwinfo)       winfo15 
!	logical!4 dummyL4d 
!	integer!4 dummyI4d 
!WINDOWS 

      include  'comblk98_lamp.fi' 
 
      COMPLEX  VEL(IMLAMP,JMLAMP,O:0), 
     &           VELpom2d(IMLAMP,JMLAMP),  
     &           EFFE(O:0),kappa,ui 
 
      REAL     Wek(IMLAMP,JMLAMP,O:0),deltaX,deltaY,
     &           rI(IMLAMP,JMLAMP)	       
 
!--------------------------------------------------------------------------!
      include 'params98_lamp.fi'             

!      deltaX=DX(1,1)
!      deltaY=DY(1,1)
!      deltaxlamp=deltax/2

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
!!                       EKMAN SPIRAL SUB_MODEL                          !!! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

!-----trascrittura in forma complessa delle velocita' di pom2d 
      pi=acos(-1.)
      ui=(0,1) 
      do i=1,IMLAMP
       do j=1,JMLAMP 
        VELpom2d(i,j)=UAB(i+IOLAMP-1,j+JOLAMP-1)+ui
     &               *VAB(i+IOLAMP-1,j+JOLAMP-1) 
       enddo 
      enddo 
!-----calcoli col PROFILO di EKMAN per uno strato FINITO 
      kappa=(1+ui)*pi/(dE/deltaZ)
!-----calcolo di VEL all'interno della colonna d'acqua 
      do i=1,IMLAMP 
       do j=1,JMLAMP 
        do k=0,O,-1  
         HH=H(i+IOLAMP-1,j+JOLAMP-1)*Fsc/deltaZ
         if(k.ge.-NINT(HH))then 
          EFFE(k)=(exp(kappa*(HH+k))-exp(-kappa*(HH+k))  ) 
     &           /(exp(kappa*HH/2)  -exp(-kappa*HH/2)    )**2
          VEL(i,j,k)=VELpom2d(i,j)*HH*kappa*EFFE(k) 
         else 
          VEL(i,j,k)=0 
         endif 
        enddo 
       enddo 
      enddo 
!-----calcolo della Wekman all'interno della griglia 
      do i=2,IMLAMP-1 
       do j=2,JMLAMP-1 
        do k=-1,O,-1
         HH=H(i+IOLAMP-1,j+JOLAMP-1)*Fsc/deltaZ
         if(k.ge.-NINT(HH))then 
          Wek(i,j,k)=Wek(i,j,k+1)+deltaZ*( 
     &      REAL((VEL(i+1,j,k+1)-VEL(i-1,j,k+1))/(2*deltaX)) 
     &     +IMAG((VEL(i,j+1,k+1)-VEL(i,j-1,k+1))/(2*deltaY)) 
     &                                   ) 
         else 
          Wek(i,j,k)=0 
         endif 
        enddo 
       enddo 
      enddo 
!-----assegnazioni della Wekman ai bordi della griglia
      do k=0,O+1
       do i=1,IMLAMP
        Wek(i,1,k)= Wek(i,2,k)             !Sud
        Wek(i,JMLAMP,k)= Wek(i,JMLAMP-1,k) !Nord
       enddo
       do j=1,JMLAMP
        Wek(1,j,k)=Wek(2,j,k)              !West
        Wek(IMLAMP,j,k)=Wek(IMLAMP-1,j,k)  !Est
       enddo
      enddo
!-----assegnazione delle velocita` calcolate da LAMP
      do k=O,0
       do j=1,JMLAMP
        do i=1,IMLAMP
         Ulamp(i,j,k)=real(Vel(i,j,k))
         Vlamp(i,j,k)=imag(Vel(i,j,k))
         Wlamp(i,j,k)=Wek(i,j,k) 
        enddo 
       enddo 
      enddo 

      IPRINTCORR=0.041666667*24*3600/DTI !OGNI ORA  
      if(mod(IINT,iPRINTCORR).eq.0)then 
      open(127,file=datadir//'corrlamp'//recNUMsim//'.txt',
     &access='append') 
      write(127,'(I12,15F12.5)')IINT
     &         ,Ulamp(9,14,-4),Vlamp(9,14,-4),Wlamp(9,14,-4)
     &         ,Ulamp(9,13,-4),Vlamp(9,13,-4),Wlamp(9,13,-4)
     &         ,Ulamp(8,14,-4),Vlamp(8,14,-4),Wlamp(8,14,-4)
     &         ,Ulamp(8,13,-4),Vlamp(8,13,-4),Wlamp(8,13,-4)
      close(127) 
      endif
!	write(*,*) 'fine tridimensionalizzazione'
!	read(*,*)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
!!                          DISPERSIONE                                    ! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

!-----RILASCIO CONTINUO 
      if(tiporilascio.eq.1) then

        if(iINT*iFLUXSORGENTE.le.Nparticelle)then
         newNpart=Icnate+iFLUXSORGENTE
        else
         newNpart=0
         write(*,*) 'iINT*iFLUXSORGENTE > Nparticelle'
	 stop
        endif 

          do Ip=Icnate+1,newNpart 
           SURVPROB(Ip)=1 
           Xpart(Ip)=iSORGENTE*deltaX      
           Ypart(Ip)=jSORGENTE*deltaY 
           Zpart(Ip)=kSORGENTE*deltaZ 
          enddo 
          Icnate=newNpart  
      endif!(tiporilascio.eq.1)  

!-----RILASCIO PERIODICO
!      IF(tiporilascio.eq.2) THEN           
!       if((IINT/iperiod)*iperiod.eq.IINT) then
!        do k=O,0       
!         do J=1,JMLAMP-1          
!          do I=1,IMLAMP-1 
!           newNparticelle=CONCperiod(i,j,k)+Icnate 
!           do Ip=Icnate+1,newNparticelle 
!            SURVPROB(Ip)=1 
!            Xpart(Ip)=i*deltaX      
!            Ypart(Ip)=j*deltaY 
!            Zpart(Ip)=k*deltaZ  
!           enddo 
!           Icnate=newNparticelle
!          enddo    
!         enddo
!        enddo
!       endif 
!      ENDIF  
         
 
! ASSEGNAZIONE DI SIGMA in base a horizontal eddy viscosity di POM
!	do I=1,IMLAMP 
!	   do J=1,JMLAMP 
!	      SIGMA(i,j)=sqrt( 2*AAM2D(i,j)*DTI ) 
!	   enddo 
!	enddo    
 
!##################### inizio del ciclo per le particelle ################### 
      do Ip=1,Nparticelle  

      Xold=Xpart(Ip) 
      Yold=Ypart(Ip) 
      Zold=Zpart(Ip) 	                  
      IF(SURVPROB(Ip).le.0) THEN    !particelle "morte"

       GOTO 11111

      ELSE                          !particelle "vive"

       IF(typepart.eq.1) THEN       !particelle decadenti 
        tau=T90*3600/(DTI*2.3025851) 
        SURVPROB(Ip)=1-1/tau 
        call random(r)               
        IF(SURVPROB(Ip).lt.r)THEN  
         SURVPROB(Ip)=0 
         Icmorte=Icmorte+1  
         cycle           
        ENDIF 
       ENDIF 
!-----assegnazione della posizione 
      XX=Xold/deltaX  
      YY=Yold/deltaY 
      ZZp=Zold/deltaZ 
      XX=XX+1 !con pom si parte da 1 anziche' da 0
      YY=YY+1 !"
      Ixx=XX  
      Iyy=YY  
      Izz=ZZp 
      Fxx=XX-Ixx  
      Fyy=YY-Iyy  
      Fzz=ZZp-Izz 
!-----calcolo delle distanze    
      d1=sqrt(fxx**2    +fyy**2    +fzz**2) 
      d2=sqrt((1-fxx)**2+(1-fyy)**2+(1-fzz)**2) 
      d3=sqrt((1-fxx)**2+fyy**2    +fzz**2)  
      d4=sqrt((1-fxx)**2+(1-fyy)**2+fzz**2)  
      d5=sqrt((1-fxx)**2+fyy**2    +(1-fzz)**2) 
      d6=sqrt(fxx**2    +(1-fyy)**2+fzz**2) 
      d7=sqrt(fxx**2    +fyy**2    +(1-fzz)**2) 
      d8=sqrt(fxx**2    +(1-fyy)**2+(1-fzz)**2)   
!-----calcolo dei pesi           
      w1=d2*d3*d4*d5*d6*d7*d8 
      w2=d1*d3*d4*d5*d6*d7*d8 
      w3=d1*d2*d4*d5*d6*d7*d8 
      w4=d1*d2*d3*d5*d6*d7*d8 
      w5=d1*d2*d3*d4*d6*d7*d8 
      w6=d1*d2*d3*d4*d5*d7*d8 
      w7=d1*d2*d3*d4*d5*d6*d8  
      w8=d1*d2*d3*d4*d5*d6*d7 
      den=w1+w2+w3+w4+w5+w6+w7+w8 
!-----interpolazione delle velocita'  
      UU=w1/den*REAL(VEL(Ixx  ,Iyy  ,Izz  ))  
     &  +w2/den*REAL(VEL(Ixx+1,Iyy+1,Izz+1))  
     &  +w3/den*REAL(VEL(Ixx+1,Iyy  ,Izz  )) 
     &  +w4/den*REAL(VEL(Ixx+1,Iyy+1,Izz  )) 
     &  +w5/den*REAL(VEL(Ixx+1,Iyy  ,Izz+1)) 
     &  +w6/den*REAL(VEL(Ixx  ,Iyy+1,Izz  )) 
     &  +w7/den*REAL(VEL(Ixx  ,Iyy  ,Izz+1)) 
     &  +w8/den*REAL(VEL(Ixx  ,Iyy+1,Izz+1))  

      VV=w1/den*IMAG(VEL(Ixx  ,Iyy  ,Izz  ))  
     &  +w2/den*IMAG(VEL(Ixx+1,Iyy+1,Izz+1))  
     &  +w3/den*IMAG(VEL(Ixx+1,Iyy  ,Izz  )) 
     &  +w4/den*IMAG(VEL(Ixx+1,Iyy+1,Izz  )) 
     &  +w5/den*IMAG(VEL(Ixx+1,Iyy  ,Izz+1)) 
     &  +w6/den*IMAG(VEL(Ixx  ,Iyy+1,Izz  )) 
     &  +w7/den*IMAG(VEL(Ixx  ,Iyy  ,Izz+1)) 
     &  +w8/den*IMAG(VEL(Ixx  ,Iyy+1,Izz+1))
 
      WW=w1/den*Wek(Ixx  ,Iyy  ,Izz  )  
     &  +w2/den*Wek(Ixx+1,Iyy+1,Izz+1)  
     &  +w3/den*Wek(Ixx+1,Iyy  ,Izz  ) 
     &  +w4/den*Wek(Ixx+1,Iyy+1,Izz  ) 
     &  +w5/den*Wek(Ixx+1,Iyy  ,Izz+1) 
     &  +w6/den*Wek(Ixx  ,Iyy+1,Izz  ) 
     &  +w7/den*Wek(Ixx  ,Iyy  ,Izz+1) 
     &  +w8/den*Wek(Ixx  ,Iyy+1,Izz+1) 

!-----calcolo degli spostamenti deterministici  
      saltoX=UU*DTI   
      saltoY=VV*DTI   
      saltoZ=(Vs+WW)*DTI    
      Xdet=Xold+saltoX 
      Ydet=Yold+saltoY 
      Zdet=Zold+saltoZ 
 
!-----CONTROLLO SPOSTAMENTI DETERMINISTICI 
      IXvicino=NINT(Xdet/deltaX) 
      IYvicino=NINT(Ydet/deltaY) 
      spostx=xdet-deltaX*IXvicino
      sposty=ydet-deltaY*IYvicino
      spostx=(xdet+deltaX)-deltaX*IXvicino 
      sposty=(ydet+deltaY)-deltaY*IYvicino 

      PROF=-H(IXvicino+IOLAMP,IYvicino+JOLAMP) 

!-----bcond E,W,N,S
      IF(  IXvicino.gt.IMLAMP.or.(ixvicino.eq.IMLAMP.and.spostx.ge.0) 
     & .or.IXvicino.lt.1.or.(ixvicino.eq.1.and.spostx.le.0) 
     & .or.IYvicino.gt.JMLAMP.or.(iyvicino.eq.JMLAMP.and.sposty.ge.0) 
     & .or.IYvicino.lt.1.or.(iyvicino.eq.1.and.sposty.le.0))THEN 
       SURVPROB(Ip)=-2   
       Icfuori=Icfuori+1 
       goto 11111 
      ENDIF 
!-----bcond "spiaggia"
      if (PROF.eq.-1) then 
       Xdet=Xold 
       Ydet=Yold 
       Zdet=Zold
      endif 
!-----bcond superficie mare
      if (Zdet.gt.0) then
       Zdet = Zold
      endif
!-----bcond fondo con biodegradazione
      if (Zdet.lt.PROF) then
       IpartBOTT = IpartBOTT + 1
       SURVPROB(Ip) = -666
       Xdet = Xold 
       Ydet = Yold 
       Zdet = PROF
      else
!-----FINE CONTROLLO

!     calcolo del PROFILO DI sigma 
      sigmaPROF=sigma(Ixx,Iyy)*(1-Zdet/(-H(Ixx,Iyy))) ! qui ho messo il -H 

!     estrazione dei tre numeri pseudorandom 
      g=0 
      do I=1,12 
       r=ranx(0)
       g=g+r-0.5 
      enddo 
      saltoRX=g*sigmaPROF

      g=0 
      do I=1,12 
       r=ranx(0)
       g=g+r-0.5 
      enddo 
      saltoRY=g*sigmaPROF   
   
      g=0 
      do I=1,12 
       r=ranx(0)
       g=g+r-0.5 
      enddo
      saltoRZ=g*sigmaPROF*Crid !coefficiente di riduzione 

!-----assegnazione delle nuove posizioni 
      Xnew=Xdet+saltoRX 
      Ynew=Ydet+saltoRY   
      Znew=Zdet+saltoRZ 

!-----CONTROLLO SPOSTAMENTI RANDOM 
      IXvicino=NINT(Xnew/deltaX)
      IYvicino=NINT(Ynew/deltaY) 
      spostx=xnew-deltaX*IXvicino
      sposty=ynew-deltaY*IYvicino
      spostx=(xnew+deltaX)-deltaX*IXvicino 
      sposty=(ynew+deltaY)-deltaY*IYvicino 

      PROF=-H(IXvicino+IOLAMP,IYvicino+JOLAMP) 
!-----bcond E,W,N,S
      IF(  IXvicino.gt.IMLAMP.or.(ixvicino.eq.IMLAMP.and.spostx.ge.0) 
     & .or.IXvicino.lt.1.or.(ixvicino.eq.1.and.spostx.le.0) 
     & .or.IYvicino.gt.JMLAMP.or.(iyvicino.eq.JMLAMP.and.sposty.ge.0) 
     & .or.IYvicino.lt.1.or.(iyvicino.eq.1.and.sposty.le.0))THEN 
       SURVPROB(Ip)=-2   
       Icfuori=Icfuori+1 
       goto 11111 
      ENDIF 
!-----bcond "spiaggia"
      if (PROF.eq.-1) then 
       Xnew=Xdet 
       Ynew=Ydet 
       Znew=Zdet 
      endif 
!-----bcond superficie mare
      if (Znew.gt.0) then
       Znew = Zdet
      endif
!-----bcond fondo con biodegradazione
      if (Znew.lt.PROF) then
       IpartBOTT = IpartBOTT + 1
       SURVPROB(Ip) = -666
       Xnew = Xdet 
       Ynew = Ydet 
       Znew = PROF
      endif
!-----FINE CONTROLLO

      endif!(Zdet.lt.PROF)deterministico

      Xpart(Ip)=Xnew 
      Ypart(Ip)=Ynew 
      Zpart(Ip)=Znew 

      endif!(SURVPROB(Ip).gt.0)
11111  continue       

       enddo!Ip=1,Nparticelle

!      write(*,*) 'fine ciclo particelle'
!      read(*,*)


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
!!                    output per Findlay-Watling model                    !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

!-----interpolazione velocita' a 1 mt dal fondo e sommatoria
      do j=1,JMLAMP
       do i=1,IMLAMP
        Vbot(i,j) = Vbot(i,j)
     &   +( 1*SQRT(Ulamp(i,j,Kbot(i,j))*Ulamp(i,j,Kbot(i,j))
     &            +Vlamp(i,j,Kbot(i,j))*Vlamp(i,j,Kbot(i,j))))/deltaZ
       enddo
      enddo

      if(MOD(IINT,2*IORA).eq.0) then
       open(66,file=datadir//'findlay'//recNUMsim//'.txt',
     &         status='unknown',access='append')                               
       write(66,*) 'IINT=',IINT 

!-----scrittura coord. particelle arrivate sul fondo in due ore
       write(66,*)' coordinate delle particelle sul fondo'
       write(66,*)'      Ip      Xpart(Ip)    Ypart(Ip) '
       do Ip=1,Nparticelle
        if(SURVPROB(Ip).eq.-666) then
         write(66,'(I12,2F12.4)') Ip,Xpart(Ip),Ypart(Ip)
	 SURVPROB(Ip)=-667
        endif
       enddo
!-----scrittura Vbot media su 2 h in [cm/s] e azzeramento
      write(66,*)' velocita ad 1 m dal fondo'
      write(66,*)'       i          j        Vbot(i,j) '
      do i=1,IMLAMP
       do j=1,JMLAMP
        Vbot(i,j) = Vbot(i,j)*100/(2*IORA)
        write(66,'(2I12,F12.4)') i,j,Vbot(i,j)
        Vbot(i,j)=0
       enddo
      enddo

      close(66)
      endif!(MOD(IINT,I2ORE).eq.0)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
!!                           print section                                !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
      if(mod(IINT,iPRINT).eq.0)then
!WWWWW 
!	dummyL4d=initialsettings() 
!     unit 15 -> messaggi passi temporali per LAMP3D 
!	open(unit=15,file='user',title='unit=15   *!! RUNNING LAMP3D !!!') 
!	wc15%numxpixels =800 
!	wc15%numypixels =600 
!	wc15%numtextcols=-1 
!	wc15%numtextrows=-1 
!	wc15%numcolors  =-1 
!	wc15%fontsize   =#0008000E 
!	dummyL4d         =setwindowconfig(wc15) 
 
!	winfo15.TYPE=qwin$set 
!	winfo15.X   =0 
!	winfo15.Y   =0 
!	winfo15.W   =70 
!	winfo15.H   =100 
!	dummyI4d=setwsizeqq(15,winfo15) 
!WWWWW 
!      messaggio sullo schermo per LAMP3D 
       write(*,*) 
       write(*,*) IINT 
       write(*,*)'                     part. nate         ->',Icnate 
       write(*,*)'                     part. decadute     ->',Icmorte 
       write(*,*)'                     part. fuori griglia->',Icfuori    
       write(*,*)'                     part. sul fondo    ->',IpartBOTT

!-----azzeramento della matrice di concentrazione
      do k=O,0       
       do J=1,JMLAMP          
        do I=1,IMLAMP
         CONC(i,j,k)=0.                                          
        enddo 
       enddo
      enddo 
!-----aggiorna gli elementi della matrice della concentrazione 
      do Ip=1,Nparticelle          
       IF(SURVPROB(Ip).gt.0)THEN !!!conto solo le particelle vive 
        Ixx=Xpart(Ip)/deltaX 
        Iyy=Ypart(Ip)/deltaY  
        Izz=Zpart(Ip)/deltaZ
        CONC(Ixx,Iyy,Izz)=CONC(Ixx,Iyy,Izz)+1  
       ENDIF 
      enddo  
 
      endif!(mod(IINT,iPRINT).eq.0)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
      RETURN
      END 
! *********************************************************************
!       ***************************************************************
!       **                                                           **
!       **  function RANX                                            **
!       **                                                           **
!       **  RANX(0) returns a random floating point number in [0,1[  **
!       **  initialize with RANX(seed) with a nonzero seed           **
!       **                                                           **
!       **  (C) ANZ 1996  (Alain NOULLEZ, anz@obs-nice.fr)           **
!       **                                                           **
!       ***************************************************************
        REAL      FUNCTION RANX (seed)
        IMPLICIT  NONE
        SAVE      rvs,rjp,rkp
        INTEGER*4 rvs(0:54),lseed
        INTEGER   rjp,rkp,n,seed
        REAL      RANMAX
        PARAMETER (RANMAX = 4294967296.0)
        IF (seed .NE. 0) THEN
           lseed = seed
           rkp = 0
           DO n = 1,55
              lseed = lseed*69069+1
              rvs(rkp) = lseed
              rkp = rkp+21
              IF (rkp .GE. 55) rkp = rkp-55
           ENDDO
           rjp = 24
           DO n = 1,220
              rjp = rjp-1
              IF (rjp .LT. 0) rjp = 54
              rkp = rkp-1
              IF (rkp .LT. 0) rkp = 54
              rvs(rkp) = rvs(rkp)+rvs(rjp)
           ENDDO
        ELSE
           rjp = rjp-1
           IF (rjp .LT. 0) rjp = 54
           rkp = rkp-1
           IF (rkp .LT. 0) rkp = 54
           rvs(rkp) = rvs(rkp)+rvs(rjp)
        ENDIF
        RANX = FLOAT(rvs(rkp))/RANMAX+0.5
        RETURN
        END
